/*
 * Simulation.java
 *
 * Created on 22 novembre 2004, 18.18
 */

package sid;

import sid.gui.*;


import alice.tucson.api.*;
import alice.logictuple.*;
import java.math.*;
import java.util.*;
import sid.agent.*;
import alice.tuprolog.Term;
import alice.tuprolog.Number;
/**
 *
 * @author  matteo
 */
public class Simulation {
    
    //specifica Respect relativa al centro di tuple mineField
    final static String RSpect_MINEFIELD=/*"reaction(out(cell(X,Y,agent(Type,Name))),(out_tc("+sid.gui.SimulationGUI.TUPLE_CENTRE_RADIOCHANNEL+",agent(X,Y,Type,Name)))).\n */" reaction(out(incUnminedMines),(in_r(incUnminedMines),in_r(unminedMines(N)),N1 is N+1,out_r(unminedMines(N1)))).\n reaction(inp(mine(X,Y,AgName)),(pre,in_r(cell(X,Y,mine)),out_r(mine(X,Y,AgName)),out_tc("+sid.gui.SimulationGUI.TUPLE_CENTRE_RADIOCHANNEL+",free_tmp(X,Y,AgName)))). \n reaction(out(endSim),(out_r(turn(-1,-1)))). \n reaction(out(agentEnded(AgentId)),(out_r(turn(-1,-1)),in_r(no_agentEnded(N)),N1 is N+1,out_r(no_agentEnded(N1)))). \n reaction(out_r(no_agentEnded(N1)),(rd_r(totAgentNumber(N)),N is N1,out_r(simulationEnded))). \n  reaction(out(maxDim(Coord,Value)),(out_tc("+sid.gui.SimulationGUI.TUPLE_CENTRE_RADIOCHANNEL+",maxDim(Coord,Value)))). \n reaction(out(agent(X,Y,Type,Name)),(in_r(agent(X,Y,Type,Name)),in_r(cell(_,_,agent(Type,Name))),out_r(cell(X,Y,agent(Type,Name))),out_tc("+sid.gui.SimulationGUI.TUPLE_CENTRE_RADIOCHANNEL+",agent_tmp(X,Y,Type,Name)))). \n reaction(out(turn(No,NoAgent)),(rd_r(totAgentNumber(NoAgent)),in_r(turn(No,NoAgent)),out_r(turn_end(No)))).";
 //reaction(out(turn(N,agent(X,Y,detect,Name))),(Xstart is X-1,Ystart is Y-1,out_r(external_loop(Xstart,Ystart)))).   reaction(out_r(external_loop(X1,Y1)),()),out_tc("+sid.gui.SimulationGUI.TUPLE_CENTRE_RADIOCHANNEL+",),Y2 is Y1+1,out_r(external_loop(Xstart,Ystart)))).                (in_r(cell(_,_,agent(Type,Name))),out_r(cell(X,Y,agent(Type,Name))),out_tc("+sid.gui.SimulationGUI.TUPLE_CENTRE_RADIOCHANNEL+",agent_tmp(X,Y,Type,name))))).";     (X1 is X-1,Y1 is Y-1,in_r(cell(X1,Y1,mine)),out_tc("+sid.gui.SimulationGUI.TUPLE_CENTRE_RADIOCHANNEL+",mine(X1,Y1,none)))). \n reaction(out(agent(X,Y,detect,Name)),(X1 is X-1,Y1 is Y-1,in_r(cell(X1,Y1,mine)),out_tc("+sid.gui.SimulationGUI.TUPLE_CENTRE_RADIOCHANNEL+",mine(X1,Y1,none)))).";
    
    //specifica Respect relativa al centro di tuple mineField
    final static String RSpect_RADIOCHANNEL="reaction(out(agent_tmp(X,Y,Type,Name)),(in_r(agent_tmp(X,Y,Type,Name)),in_r(agent(_,_,Type,Name)),out_r(agent(X,Y,Type,Name)))). \n reaction(in_r(free_tmp(X,Y,AgentName)), (rd_r(maxDim(x,Max_X)),rd_r(maxDim(y,Max_Y)),X>=0 , Y>=0 , X<Max_X , Y<Max_Y ,no_r(free(X,Y,_)),out_r(free(X,Y,AgentName)))). \n reaction(out_r(free(X,Y,AgentName)), (in_r(mine(X,Y,_)))). \n reaction(out(free_tmp(X,Y,AgentName)),(in_r(free_tmp(X,Y,AgentName)))). \n reaction(out(mine_tmp(X,Y,AssignedUnmineAgent)),(in_r(mine_tmp(X,Y,AssignedUnmineAgent)))). \n reaction(in_r(mine_tmp(X,Y,AssignedUnmineAgent)),(no_r(mine(X,Y,_)),out_r(mine(X,Y,AssignedUnmineAgent)))). \n reaction(inp(rd_all(T,L)),(pre,out_r(rdall_collect(T,[])))). \n reaction(out_r(rdall_collect(T,L)),(current_tuple(rdall_collect(T1,_)),in_r(T1),in_r(rdall_collect(T,L)),out_r(rdall_collect(T,[T1|L])))). \n reaction(out_r(rdall_collect(T,_)),(current_tuple(rdall_collect(T1,_)),no_r(T1),in_r(rdall_collect(T,L)),out_r(rd_all(T,L)),out_r(rdall_restore(L)) )). \n reaction(out_r(rdall_restore([])),(in_r(rdall_restore([])) )). \n reaction(out_r(rdall_restore([H|T])),(in_r(rdall_restore([H|T])),out_r(H),out_r(rdall_restore(T)) )).";
    
    //dimensione x del campo minato
    private int X_DIMENSION;
    
    //contatore: tiene conto del numero di turni che sono stati effettuati
    private int turnNumber;
    
    //dimensione y del campo minato
    private int Y_DIMENSION;
    
    //numero agenti rilevatori della simulazione
    private int nA;
        
    //numero agenti sminatori della simulazione
    private int nB;
    
    //contesto di tucson necessario per interfacciarmi con il nodo
    private TucsonContext cn=null;
    
    //rappresenta il centro di tuple principale che consente di rappresentare il campo minato
    private TupleCentreId tcMineField;
    
    //rappresenta il centro di tuple principale che consente di rappresentare il radio channel usato dagli
    //agenti per comunicare tra loro
    private TupleCentreId tcRadioChannel;
    
    //rappresenta la matrice del campo minato
    private int[][] mineField;
    
    //numero totale di mine presenti nel campo minato
    private int totMines;
    
    //numero totale di mine rimosse durante la simulazione
    private Integer unminedMines;
    
    //posto a true quando la simulazione deve terminare (disinnescate tutte le mine)
    private boolean simEnded;
    /** 
     *Creates a new instance of Simulation
     *
     */
    public Simulation() throws Exception {
              
        
           this.initSim(0,0,0,0);
           
        
    }//end-constructor
    
    /** 
     *Creates a new instance of Simulation
     *@param nX numero di caselle sull'asse X
     *@param nY numero di caselle sull'asse Y
     *
     */
    public Simulation(int nX,int nY) throws Exception {
              
        
           this.initSim(0,0,nX,nY);
           
        
    }//end-constructor
    
    /** 
     *Creates a new instance of Simulation
     *@param nA numero di agenti tipo A (vedono mine) da creare
     *@param nB numero agenti tipo B (disinnescano mine) da creare
     *@param nX numero di caselle sull'asse X
     *@param nY numero di caselle sull'asse Y
     *
     */
    public Simulation(int nA,int nB,int nX,int nY) throws Exception {
                
        
           this.initSim(nB,nA,nX,nY);
           
        
        
    }//end-constructor
    
    
    /** 
     *Initialize a new simulation object
     *@param nA numero di agenti tipo A (vedono mine) da creare
     *@param nB numero agenti tipo B (disinnescano mine) da creare
     *@param nX numero di caselle sull'asse X
     *@param nY numero di caselle sull'asse Y
     *
     */
     private void initSim(int nA,int nB,int nX,int nY) throws Exception {
        
            this.X_DIMENSION=nX;
            this.Y_DIMENSION=nY;
            this.nA=nA;
            this.nB=nB;
            this.unminedMines=new Integer(0);
            this.simEnded=false;
            //System.out.println(""+this.unminedMines);
            
            this.initMatrix();
            
            //inizializzazione a 0 del contatore che tiene conto del numero di turni effettuati
            this.turnNumber=0;
            
            //creo il tuplecenter principale che rappresenta il campo minato
            this.tcMineField=new TupleCentreId(sid.gui.SimulationGUI.TUPLE_CENTRE_MINEFIELD);
            
            
            //creo il tuplecenter principale che rappresenta il campo minato
            this.tcRadioChannel=new TupleCentreId(sid.gui.SimulationGUI.TUPLE_CENTRE_RADIOCHANNEL);
            
            //genero il TucsonContext   
            this.cn=Tucson.enterDefaultContext();
            System.out.println("creo un nuovo contesto Tucson: "+this.cn);
            
            //provo a fare una out per vedere se il nodo  attivo: altrimenti viene lanciata l'eccezione
            this.cn.out(this.tcMineField,new LogicTuple("isActive",new Value("yes")));

            //se il nodo  attivo elimino dal tc questa tupla di prova
            this.cn.in(this.tcMineField,new LogicTuple("isActive",new Value("yes")));
            
            
            //pulisco il tc relativo al radio channel
            this.clearTupleCentre(this.tcRadioChannel);
            
            
            //genera i dati relativi ad un nuovo campo minato: inoltre crea anche il centro di tuple mineField utilizzato per rappresentare l'ambiente simulato
            this.generateNewMineField();
            
            //setto le specifiche del tc mineField
            this.setTCSpecifications(this.tcMineField,this.RSpect_MINEFIELD);

            //setto le specifiche del tc mineField
            this.setTCSpecifications(this.tcRadioChannel,this.RSpect_RADIOCHANNEL);
            
            //emetto le tuple che stabiliscono le massime dimensioni coordinate del campo minato
            this.cn.out(this.tcMineField,new LogicTuple("maxDim",new Value("x"),new Value(this.X_DIMENSION))); 
            this.cn.out(this.tcMineField,new LogicTuple("maxDim",new Value("y"),new Value(this.Y_DIMENSION)));
            
            //generazione degli agenti 
            this.generateAgents();
            
           
            
    }//initSim
    
    /**
     *metodo utilizzato per inizializzare la matrice che  utilizzata
     *per aggiornamre il campo minato presentato all'utente: tutti gli 
     *elementi della matrice vengono inizializzati al valore -1 (cella vuota).
     *
     */
     private void initMatrix(){
         
         //inizializzazione matrice campo minato: assegno valore al riferimento
         this.mineField=new int[this.Y_DIMENSION][this.X_DIMENSION];
         
         for(int i=0;i<this.Y_DIMENSION;i++){
             
             //scansione delle colonne
             for(int k=0;k<this.X_DIMENSION;k++){
                 //inizializzazione cella
                 this.mineField[i][k]=-1;
                 
                         
             }//for
             
        }//for
         
     }//initMatrix
     
     
    /**
     *questo metodo viene utilizzato per generare gli agenti della simulazione
     *
     */
     private void generateAgents()throws Exception{
         
         //generatore di numeri casuali: per determinare casualmente la poszione che avranno gli agenti da creare
         Random rm=new Random();
         
         //genero gli agenti che vedono le mine
         for(int i=1;i<=this.nA;i++){
             
             //scelta casuale della posizione del nuovo agente
             int xPos=(int)(rm.nextDouble()*this.X_DIMENSION);
             int yPos=(int)(rm.nextDouble()*this.Y_DIMENSION);
             
             //si controlla se nella posizione scelta non sia gi stato posizionato un altro agente
             int actualPos=this.mineField[yPos][xPos];
             
             while(actualPos==1 || actualPos==2){
                 
                 xPos=(int)(rm.nextDouble()*this.X_DIMENSION);
                 yPos=(int)(rm.nextDouble()*this.Y_DIMENSION);
                 
                 actualPos=this.mineField[yPos][xPos];
                 
             }//while
             
             //aggiornamento dell'array della simulazione
             this.mineField[yPos][xPos]=1;
             
             
             //rimozione eventuale della cella contentente una mina ma ora assegnata ad un agente
             LogicTuple minePresent=this.cn.inp(this.tcMineField,new LogicTuple("cell",new Value(xPos),new Value(yPos),new Var("T")));
             
             if(minePresent!=null) this.totMines--;
             
             //viene impostata la posizione dell'agente anche nel centro di tuple che rappresenta l'ambiente ovvero il campo minato
             this.cn.out(this.tcMineField,new LogicTuple("cell",new Value(xPos),new Value(yPos),new Value("agent",new Value("detect"),new Value("d"+i))));
             
             //generazione nuovo agente di tipo detect
             new DetectAgent(xPos,yPos,this.mineField,new AgentId("d"+i)).spawn();
             
            
             
         }//for
         
         //genero gli agenti sminatori
         for(int i=1;i<=this.nB;i++){
             
             //scelta casuale della posizione del nuovo agente
             int xPos=(int)(rm.nextDouble()*this.X_DIMENSION);
             int yPos=(int)(rm.nextDouble()*this.Y_DIMENSION);
             
             //si controlla se nella posizione scelta non sia gi stato posizionato un altro agente
             int actualPos=this.mineField[yPos][xPos];
             
             while(actualPos==1 || actualPos==2){
                 
                 xPos=(int)(rm.nextDouble()*this.X_DIMENSION);
                 yPos=(int)(rm.nextDouble()*this.Y_DIMENSION);
                 
                 actualPos=this.mineField[yPos][xPos];
                 
             }//while
             
             //aggiornamento dell'array della simulazione
             this.mineField[yPos][xPos]=2;
             
             
             //rimozione eventuale della cella contentente una mina ma ora assegnata ad un agente
             LogicTuple minePresent=this.cn.inp(this.tcMineField,new LogicTuple("cell",new Value(xPos),new Value(yPos),new Var("T")));
             
             if(minePresent!=null) this.totMines--;
             
             //viene impostata la posizione dell'agente anche nel centro di tuple che rappresenta l'ambiente ovvero il campo minato
             this.cn.out(this.tcMineField,new LogicTuple("cell",new Value(xPos),new Value(yPos),new Value("agent",new Value("unMine"),new Value("u"+i))));
             
             //System.out.println(""+this.unminedMines);
             
             //generazione nuovo agente di tipo unMine
             new UnMineAgent(xPos,yPos,this.mineField,new AgentId("u"+i)).spawn();
             
             
             
             
         }//for
         
         //emissione della tupla che memorizza il numero totale di agenti (sminatori + rilevatori) che interagiscono con il campo minato
         this.cn.out(this.tcMineField,new LogicTuple("totAgentNumber",new Value(nA+nB)));       
     }//generateAgents
     
   /**
    *questo metodo consente di specificare il respect di un tc dato
    *@param tc il tuplecentre del quale specificare il comportamento
    *@parm spec stringa contenente specifiche di comportamento respectT valide
    *
    */     
     private void setTCSpecifications(TupleCentreId tc,String spec)throws Exception{
         
          if(this.cn.getSpec(tc).length()<=0){
                //se non era gi stato impostato il comportamento in precedenza, setto il comportamento del centro di tuple mineField
                //System.out.println("respect: "+this.cn.getSpec(tc));
                this.cn.setSpec(tc,spec);
            }//if
     }//setTCSpec
     
    /**
     *metodo utilizzato per cancellare dal tc mineField le tuple relative ad una precedente simulazione
     *
     */
     private void clearMineFieldTC()throws Exception{
         
         
         this.clearTupleCentre(this.tcMineField);
         
             
         
     }//clearMineField
    
     
     /**
      *metodo usato per svuotare completamente un tc dato
      *@param tc il tuple center da svuotare
      *
      */
     private void clearTupleCentre(TupleCentreId tc)throws Exception{
         
         //rimuovo le specifiche eventualmente impostate
         this.cn.setSpec(tc,"");
         
         LogicTuple inTuple=this.cn.inp(tc,new LogicTuple(new Var("X")));
         
         //elimino fino a che il tc non  completamente vuoto
         while(inTuple!=null)
             inTuple=this.cn.inp(tc,new LogicTuple(new Var("X")));
         
         
     }//clearTupleCenter
     
     
     /**
     *genera un nuovo campo minato e imposta i valori nel nodo Tucson
     */
    private void generateNewMineField() throws Exception{
        
        this.totMines=0;
        
        //System.out.println(""+new LogicTuple("unminedMines",new Value(this.unminedMines.intValue())));
        
        
        System.out.println("yDim: "+this.Y_DIMENSION+" xDim: "+this.X_DIMENSION);
        
        this.clearMineFieldTC();
        
        //inizializzazione tupla numero totale di mine disinnescate
        this.cn.out(this.tcMineField,new LogicTuple("unminedMines",new Value(this.unminedMines.intValue())));
        
        
        //generazione
        for(int i=0;i<this.Y_DIMENSION;i++){
             
             //scansione delle colonne
             for(int k=0;k<this.X_DIMENSION;k++){
                 //genero una mina con distribuzione di probabilit uniforme (50% di prob. di generare una mina e 50% di prob di non generarla)
                 mineField[i][k]=( Math.random()<=0.5 ? 0 : -1);
                 
                 
                     switch(mineField[i][k]){
                         case 0:{
                             //dopo aver generato la mina la si inserisce nel tuple center mineField
                             this.cn.out(this.tcMineField,new LogicTuple("cell",new Value(k),new Value(i),new Value("mine")));
                             this.totMines++;
                         }//case
                     }//switch
                     
                 
        
             }//for
        }//for
        
        //questo metodo consente di modificare il minefield creato in uno valido: ad esempio verifica che tutte le caselle attorno ad una casella non minata non
        //siano tutte completamente minate: esiste in sostanza un cammino che un agente pu usare per uscire dalla casella libera
        //this.checkMineField();
        
        
        //posizionamento degli agenti (in maniera casuale
        //this.
    }//generateNewMineField
    
    
    
    /**
     *utilizzato per controllare e, eventualmente, correggere il campo minato appena creato, in modo che sia un campo minato valido,
     *cio che, data una casella libera, esista almeno una casella adiacente senza mina, in modo da permettere ad un agente che si trovi nella casella di uscirvi
     *
     */
    private void checkMineField()throws Exception{
        
        //controllo tutte le caselle verificando che almeno una sia libera tra quelle attorno alla casella data
        for(int i=0;i<this.Y_DIMENSION;i++){
             
             //scansione delle colonne
             for(int k=0;k<this.X_DIMENSION;k++){
                 
                 int actual = mineField[i][k];
                 
                 //se la casella contiene una mina non la controllo, altrimenti se  libera controllo che tra le adiacenti ve ne sia 
                 //almeno una libera
                 if(actual==0){
                     break; //casella con una mina
                 }else{
                     
                     //controllo le mine adiacenti a quella data: se almeno una  libera allora passo a controllare la mina successiva
                     int adiacentCell;
                     
                     //indice di riga della cella adiacente: celle sulla stessa riga di quella considerata
                     int iA=i;
                     
                     //si fa variare l'indice di colonna: si controlla solo se si tratta di caselle esistenti
                     
                     //indice di colonna delle celle adiacenti
                     int kA=k-1;
                     
                     if(kA>=0){
                         
                        adiacentCell=mineField[iA][kA];
                        
                     }//if
                 }//else
                 
                 
                    
        
             }
        }
        
    }//checkMineField
    
    /**
     *metodo utilizzato per rimuovere una mina dal tc mineField
     *@param x la coordinata x della mina da rimuovere
     *@param y la coordinata y della mina da rimuovere
     *@return true se la rimozione dal campo minato va a buon fine, false altrimenti
     */
     public boolean removeMine(int x,int y){
         
         try{
             
            LogicTuple res=this.cn.inp(this.tcMineField,new LogicTuple("cell",new Value(x),new Value(y),new Value("mine")));
            
            //se presente la rimuove anche dal radioChannel ( come se l'agente umano lo comunicasse agli agenti software)
            this.cn.out(this.tcRadioChannel,new LogicTuple("free_tmp",new Value(x),new Value(y),new Value("human")));
            
            //aggiornamento della matrice per la visualizzazione grafica del campo minato
            this.mineField[y][x]=3;
            
            //aumento di 1 il numero di mine disinnescate
            this.cn.out(tcMineField,new LogicTuple("incUnminedMines"));
            
            return true;
            
         }catch(Exception e){
             
             return false;
         }
         
     }//removeMine
    
     /**
      *consente di passare al turno successivo della simulazione
      *
      */
     public void nextTurn()throws Exception{
         
         
         
         this.cn.out(this.tcMineField,new LogicTuple("turn",new Value(this.turnNumber),new Value(0)));
         
         
         //attendo che il turno sia concluso: in sospensiva
         this.cn.in(this.tcMineField,new LogicTuple("turn_end",new Value(this.turnNumber)));
         
         turnNumber++;
         
         Var unMinedMines=new Var("Unmined");
         
         this.cn.rdp(this.tcMineField,new LogicTuple("unminedMines",unMinedMines));
         
         this.unminedMines=new Integer(unMinedMines.getVarValue("Unmined").intValue());
         
         
         //controllo se  giunta la fine della simulazione
         if(this.totMines==this.unminedMines.intValue()) this.simEnded=true;
         /*
         while (this.cn.inp(this.tcMineField,new LogicTuple("turn",new Value(0),new Var("X")))!=null){
            
             index++;
             this.cn.out(this.tcMineField,new LogicTuple("turn",new Value(0),new Value(index)));
             
         }
         */
         
     }//nextTurn
     
    /**
     *restituisce la matrice contenente il campo minato 
     *@return la matrice del campo minato
     */
     public int[][] getMineFieldMatrix(){
         
         return this.mineField;
         
     }//getMineFieldMatrix
     
     
     /**
      *metodo utilizzato per richiedere alla simulazione (richiesta proveniente dall'interf. grafica)
      *di aggiornare la matrice contenente gli id che consentono di ridiscegnare il campo minato grafico
      *
      */
     /*
     public void updateMineFieldMatrix() throws Exception{
         
         for(int i=0;i<this.Y_DIMENSION;i++){
             
             for(int j=0;j<this.X_DIMENSION;j++){
                 
                 //variabile che rappresenta l'oggetto presente in una cella controllata
                 Var obj=new Var("Obj");
                 
                 LogicTuple toUpdate=this.cn.rdp(this.tcMineField,new LogicTuple("cell",new Value(j),new Value(i),obj));
                 
                 //se non viene letta alcuna tupla allora significa che la cella  vuota: si controlla se per caso, nel tc radioChannel tale tupla sia stata segnalata come libera
                 if(toUpdate==null){
                     
                     //agente che ha segnalato come libera la cella
                     Var agent=new Var("Agent");
                     LogicTuple free=this.cn.rdp(this.tcRadioChannel,new LogicTuple("free",new Value(j),new Value(i),agent));
                     System.out.println("bandiera verde");
                     if(free==null)
                         this.mineField[i][j]=-1;
                     else this.mineField[i][j]=3;
                     
                 }//if
                 
             }//for
             
         }//for
         
     }//updateMineFieldMatrix
    */
     
     /**
      *metodo utilizzato per richiede la fine di una simulazione:
      *gli agenti verranno cos terminati utilizzando il centro di tuple per comunicarglielo
      *
      */
      public void endSim()throws Exception{
          
          //emissione della tupla di fine simulazione endSim
          this.cn.out(this.tcMineField,new LogicTuple("endSim"));
          this.cn.out(this.tcMineField,new LogicTuple("no_agentEnded",new Value(0)));
          
          //attendo che tutti gli agenti siano terminati, dopodich pulisco completamente i centri di tuple
          this.cn.in(this.tcMineField,new LogicTuple("simulationEnded"));
          
          //pulizia dei tc mineField e radioChannel
          this.clearMineFieldTC();
          this.clearTupleCentre(this.tcRadioChannel);
          
          //uscita dal contesto
          this.cn.exit();
          
      }//endSim
      
      
      public int getTotMines(){
          
          return this.totMines;
      }//getTotMines
      
      
      public int getTotUnminedMines(){
          
          return this.unminedMines.intValue();
          
      }//getTotUnminedMines
     
      public boolean isSimEnded(){
          
          return this.simEnded;
          
      }//isSimEnded
      
}//end-class
