/*
 * RobotAgent.java
 *
 * Created on 1 dicembre 2004, 19.07
 */

package sid.agent;

import alice.tucson.api.*;

/**
 * Questa classe rappresenta un generico agente robot in grado di muoversi in un ambiente virtuale: in
 * particolare, in riferimento alla simulazione del campo minato, gli agenti che estenderanno questa classe
 * saranno di due tipi:<BR>
 * agenti rilevatori di mine <BR>
 * agenti sminatori
 *
 * @author  matteo
 */
public abstract class RobotAgent extends alice.tucson.api.Agent {
    
   
     
     /**
      *posizione x dell'ambiente virtuale nel quale si trova il robotAgent
      *
      */
     private int x;
     
     
     /**
      *posizione y dell'ambiente virtuale nel quale si trova il robotAgent
      *
      */
     private int y;
    
    /** 
     *costruttore
     *@param x la coordinata x che relativa alla posizione iniziale del robotAgent
     *@param y la coordinata y relativa alla posizione iniziale del robotAgent
     *@param name il nome del robot agent, ovvero il suo identificativo
     *
     */
    public RobotAgent(int x,int y,AgentId name) throws Exception {
        
        
        super(name);
        
        this.x=x;
        this.y=y;
        
            
    }//costructor
    
    
    /**
     *restituisce la coordinata 
     *x dell'ambiente virtuale alla quale si trova l'agente
     *@return coordinata x
     */
    protected int getX(){
        return this.x;
    }//getX
    
    /**
     *restituisce la coordinata 
     *y dell'ambiente virtuale alla quale si trova l'agente
     *@return coordinata y
     */
    protected int getY(){
        return this.y;
    }//getY
    
    
     /**
     *setta la coordinata 
     *x dell'ambiente virtuale alla quale si trova l'agente
     *@param la nuova coordinata x
     */
    protected void setX(int x){
        this.x=x;
    }//setX
    
     /**
     *setta la coordinata 
     *y dell'ambiente virtuale alla quale si trova l'agente
     *@param la nuova coordinata y
     */
    protected void setY(int y){
        this.y=y;
    }//setY
    
    
    /*protected void body() {
    }*/
    

    
}//end-class
