/*
 * SetNewSimDialogGUI.java
 *
 * Created on 24 novembre 2004, 23.26
 */

package sid.gui;

/**
 *
 * @author  matteo
 */
public class SetNewSimDialogGUI extends javax.swing.JDialog {
    
    /**
     *frame padre
     */
    private SimulationGUI sim;
    
    
    
    /** Creates new form SetNewSimDialogGUI */
    public SetNewSimDialogGUI(java.awt.Frame parent, boolean modal) {
        
        super(parent, modal);
        this.sim=(SimulationGUI)parent;
        initComponents();
        
    }//end-constructor
    
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        jButtonOk = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();
        jTextFieldXDim = new javax.swing.JTextField();
        jTextFieldYDim = new javax.swing.JTextField();
        jLabel2 = new javax.swing.JLabel();
        jLabel21 = new javax.swing.JLabel();
        jLabel11 = new javax.swing.JLabel();
        jLabel12 = new javax.swing.JLabel();
        jTextFieldXDetectAgent = new javax.swing.JTextField();
        jTextFieldXUnMineAgent = new javax.swing.JTextField();

        getContentPane().setLayout(null);

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("New Sim Parameters");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });

        jButtonOk.setText("OK");
        jButtonOk.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonOkActionPerformed(evt);
            }
        });

        getContentPane().add(jButtonOk);
        jButtonOk.setBounds(180, 240, 150, 40);

        jLabel1.setFont(new java.awt.Font("Dialog", 1, 14));
        jLabel1.setText("Detect Agent (MIN 1;MAX 4)");
        getContentPane().add(jLabel1);
        jLabel1.setBounds(10, 140, 220, 30);

        jTextFieldXDim.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jTextFieldXDimActionPerformed(evt);
            }
        });

        getContentPane().add(jTextFieldXDim);
        jTextFieldXDim.setBounds(90, 70, 63, 30);

        getContentPane().add(jTextFieldYDim);
        jTextFieldYDim.setBounds(250, 70, 60, 30);

        jLabel2.setFont(new java.awt.Font("Dialog", 1, 24));
        jLabel2.setForeground(new java.awt.Color(0, 0, 255));
        jLabel2.setText("Y");
        getContentPane().add(jLabel2);
        jLabel2.setBounds(220, 70, 30, 32);

        jLabel21.setFont(new java.awt.Font("Dialog", 1, 24));
        jLabel21.setForeground(new java.awt.Color(0, 0, 255));
        jLabel21.setText("X");
        getContentPane().add(jLabel21);
        jLabel21.setBounds(60, 70, 30, 32);

        jLabel11.setFont(new java.awt.Font("Dialog", 1, 14));
        jLabel11.setText("MineField dimension ( X: MIN 10, MAX 15 ; Y: MIN 10, MAX 15)");
        getContentPane().add(jLabel11);
        jLabel11.setBounds(10, 30, 440, 20);

        jLabel12.setFont(new java.awt.Font("Dialog", 1, 14));
        jLabel12.setText("UnMine Agent (MIN 1;MAX 4)");
        getContentPane().add(jLabel12);
        jLabel12.setBounds(10, 190, 200, 20);

        getContentPane().add(jTextFieldXDetectAgent);
        jTextFieldXDetectAgent.setBounds(250, 180, 63, 30);

        getContentPane().add(jTextFieldXUnMineAgent);
        jTextFieldXUnMineAgent.setBounds(250, 140, 63, 30);

        pack();
        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setSize(new java.awt.Dimension(520, 320));
        setLocation((screenSize.width-520)/2,(screenSize.height-320)/2);
    }//GEN-END:initComponents

    
    /**
     *metodo utilizzato per controllare la correttezza dei parametri di una nuova simulazione
     *inseriti da un utente
     *@return true se il controllo dei parametri va a buon fine, false altrimenti
     *
     */
    private boolean checkSimParam()throws Exception{
        
        int x=Integer.parseInt(this.jTextFieldXDim.getText());
        int y=Integer.parseInt(this.jTextFieldYDim.getText());
        
        int nA=Integer.parseInt(this.jTextFieldXDetectAgent.getText());
        int nB=Integer.parseInt(this.jTextFieldXUnMineAgent.getText());
        
        if(x<10 || x>15){
            this.sim.showDialogError("Il numero di caselle lungo X deve essere compreso tra 10 e 15","Errore di inserimento dei parametri della simulazione");
            return false;
        }
        
        if(y<10 || y>15){
            this.sim.showDialogError("Il numero di caselle lungo Y deve essere compreso tra 10 e 15","Errore di inserimento dei parametri della simulazione");
            return false;
        }
        
        if(x!=y){
            this.sim.showDialogError("Il numero di caselle lungo Y e lungo X deve essere uguale","Errore di inserimento dei parametri della simulazione");
            return false;
        }
        
        if(nA<1 || nA>4){
            this.sim.showDialogError("Il numero di agenti rilevatori deve essere almeno 1 e minore di 5","Errore di inserimento dei parametri della simulazione");
            return false;
        }
        
        if(nB<1  || nB>4){
            this.sim.showDialogError("Il numero di agenti sminatori deve essere almeno 1 e minore di 5","Errore di inserimento dei parametri della simulazione");
            return false;
        }
        
        this.sim.setSimulation(nA,nB,x,y);        
        
        return true;
        
        
    }//checkSimParam
    
    private void jButtonOkActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonOkActionPerformed
        try{
            //si controlla la correttezza dei parametri inseriti: se alcuni parametri non sono numerici il metodo torna una NumberFormatException
            boolean result=this.checkSimParam();
            
            if(result)
                this.close();
            
        }catch(Exception e){
            
            this.sim.showDialogError("Uno o pi parametri sono in formato non numerico","Errore di inserimento dei parametri della simulazione");
        }
    }//GEN-LAST:event_jButtonOkActionPerformed

    private void jTextFieldXDimActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jTextFieldXDimActionPerformed
        // Add your handling code here:
    }//GEN-LAST:event_jTextFieldXDimActionPerformed
    
    /** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        this.close();
    }//GEN-LAST:event_closeDialog
    
    /**
     *chiusura dialog
     */
    private void close(){
        setVisible(false);
        dispose();
    }//close
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        new SetNewSimDialogGUI(new javax.swing.JFrame(), true).show();
    }
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel jLabel21;
    private javax.swing.JTextField jTextFieldXUnMineAgent;
    private javax.swing.JLabel jLabel12;
    private javax.swing.JTextField jTextFieldXDetectAgent;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JTextField jTextFieldXDim;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JButton jButtonOk;
    private javax.swing.JTextField jTextFieldYDim;
    // End of variables declaration//GEN-END:variables
    
}
