/*
 * MineFieldGUI.java
 *
 * Created on 19 novembre 2004, 21.45
 */

package sid.gui;

import sid.*;

import javax.swing.*;
import java.awt.*;


/**
 *
 * @author  matteo
 */
public class SimulationGUI extends javax.swing.JFrame {
    
    //dimensione x del campo minato
    private int x;
    
    /*
     *directory nel quale viene lanciata la simulazione
     */
    public static String userPath;
    
    //dimensione y del campo minato
    private int y;
    
    //numero agenti sminatori da associare ad una nuova sim
    private int nA;
    
    
    //numero agenti rilevatori da associare ad una nuova sim
    private int nB;
    
    
    //nome del centro di tuple che rappresenta il campo minato
    public final static String TUPLE_CENTRE_MINEFIELD="mineField"; 
    
    
    //nome del centro di tuple che rappresenta il canale radio
    public final static String TUPLE_CENTRE_RADIOCHANNEL="radioChannel"; 
    
    public static String fileSeparator;
    
    
    //oggetti e variabili di istanza
    private MineFieldGUI m;
    
    /*
    //contesto di tucson necessario per interfacciarmi con il nodo
    private TucsonContext cn=null;
    
    /*
    //rappresenta il centro di tuple principale che consente di rappresentare il campo minato
    private TupleCentreId tcMineField;
    */
    //rappresenta la simulazione attualmente in esecuzione: null se nessuna simulazione  in corso di esecuzione
    private Simulation sim;
    
    /** Creates new form MineFieldGUI */
    public SimulationGUI() {
        
        this.userPath=System.getProperty("user.dir");
        this.fileSeparator=System.getProperty("file.separator");
        
        initComponents(); 
        
        
    }
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        jButton1 = new javax.swing.JButton();
        jButtonStop = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();
        jLabel11 = new javax.swing.JLabel();
        jLabelTotMines = new javax.swing.JLabel();
        jLabelUniminedMines = new javax.swing.JLabel();
        jMenuBar1 = new javax.swing.JMenuBar();
        jMenu1 = new javax.swing.JMenu();
        jMenuItem1 = new javax.swing.JMenuItem();
        jMenuItem2 = new javax.swing.JMenuItem();

        getContentPane().setLayout(null);

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("MineField");
        setIconImage(new ImageIcon(this.userPath+"\\images\\guiIcon.gif").getImage());
        addComponentListener(new java.awt.event.ComponentAdapter() {
            public void componentMoved(java.awt.event.ComponentEvent evt) {
                formComponentMoved(evt);
            }
        });

        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        });

        jButton1.setIcon(new ImageIcon(this.userPath+sid.gui.SimulationGUI.fileSeparator+"images"+sid.gui.SimulationGUI.fileSeparator+"buttonNext.gif"));
        jButton1.setToolTipText("Next Turn");
        jButton1.setEnabled(false);
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        getContentPane().add(jButton1);
        jButton1.setBounds(10, 10, 170, 160);

        jButtonStop.setIcon(new ImageIcon(this.userPath+sid.gui.SimulationGUI.fileSeparator+"images"+sid.gui.SimulationGUI.fileSeparator+"buttonStop.gif"));
        jButtonStop.setToolTipText("Stop Current Simulation");
        jButtonStop.setEnabled(false);
        jButtonStop.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonStopActionPerformed(evt);
            }
        });

        getContentPane().add(jButtonStop);
        jButtonStop.setBounds(10, 180, 170, 160);

        jLabel1.setFont(new java.awt.Font("Dialog", 1, 14));
        jLabel1.setText("Mine disinnescate:");
        getContentPane().add(jLabel1);
        jLabel1.setBounds(10, 440, 150, 19);

        jLabel11.setFont(new java.awt.Font("Dialog", 1, 14));
        jLabel11.setText("Numero totale mine:");
        getContentPane().add(jLabel11);
        jLabel11.setBounds(10, 370, 150, 19);

        jLabelTotMines.setFont(new java.awt.Font("Dialog", 1, 18));
        jLabelTotMines.setForeground(new java.awt.Color(0, 0, 255));
        getContentPane().add(jLabelTotMines);
        jLabelTotMines.setBounds(10, 390, 110, 40);

        jLabelUniminedMines.setFont(new java.awt.Font("Dialog", 1, 18));
        jLabelUniminedMines.setForeground(new java.awt.Color(0, 0, 255));
        getContentPane().add(jLabelUniminedMines);
        jLabelUniminedMines.setBounds(10, 470, 110, 40);

        jMenu1.setText("Menu");
        jMenuItem1.setText("New Simulation...");
        jMenuItem1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem1ActionPerformed(evt);
            }
        });

        jMenu1.add(jMenuItem1);
        jMenuItem2.setText("Exit");
        jMenuItem2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem2ActionPerformed(evt);
            }
        });

        jMenu1.add(jMenuItem2);
        jMenuBar1.add(jMenu1);
        setJMenuBar(jMenuBar1);

        pack();
        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setSize(new java.awt.Dimension(210, 581));
        setLocation((screenSize.width-210)/2,(screenSize.height-581)/2);
    }//GEN-END:initComponents

    private void jButtonStopActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonStopActionPerformed
        try{
            
            this.endPreviusSim();
            this.jButton1.setEnabled(false);
            //this.m.close();
            
            //in questo caso si annulla la simulazione e si chiude la finestra relativa alla rappresentazione grafica del campo minato stesso
            this.showDialogInfo("La simulazione  stata terminata correttamente","Simulation Ended");
           
            this.jButton1.setEnabled(false);
            this.jButtonStop.setEnabled(false);
            this.sim=null;
            
        }catch(Exception e){//eccezione nel caso in cui non sia pi in ascolto il demone relativo al nodo Tucson locale
            
            
           
            //in questo caso si annulla la simulazione e si chiude la finestra relativa alla rappresentazione grafica del campo minato stesso
            this.showDialogError("Non  pi presente alcun nodo Tucson: impossibile continuare la simulazione corrente (verr terminata)","Simulation run-time error");
            
            this.sim=null;
            
            this.m.close();
            
            this.m=null;
           
            this.jButton1.setEnabled(false);
            this.jButtonStop.setEnabled(false);
            
            
            
        }//catch
    }//GEN-LAST:event_jButtonStopActionPerformed

    private void jMenuItem2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem2ActionPerformed
        this.exitForm(new java.awt.event.WindowEvent(this,0));
    }//GEN-LAST:event_jMenuItem2ActionPerformed

    private void formComponentMoved(java.awt.event.ComponentEvent evt) {//GEN-FIRST:event_formComponentMoved
        if(evt.getSource()==this){
            
            //se c' una simulazione in esecuzione
            if(m!=null){
                //recupero la nuova posizione del frame
                Point framePos=this.getLocation();

                //imposto la nuova posizione del campo minato
                m.setLocation((int)framePos.getX()+190,(int)framePos.getY()+58);
                m.requestFocus();
            }//if
            
        }//if
    }//GEN-LAST:event_formComponentMoved

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        //m.setVisible(true);
        //m.glass.remove(7);
        try{
            
            
            this.sim.nextTurn();
            
            /*
            //aggiornamento della matrice della sim che consente di aggiornare l'interfaccia grafica
            this.sim.updateMineFieldMatrix();
            */
            
            //riferimento alla precedente visualizzazione del campo minato
            MineFieldGUI previus=m;
            
            
            m=new MineFieldGUI(this,this.x,this.y);
            
 
            //recupero la nuova posizione del frame
            Point framePos=this.getLocation();
            
            //imposto la nuova posizione del campo minato
            m.setLocation((int)framePos.getX()+200,(int)framePos.getY()+58);
           
            
            //recupero la matrice da simulation creata e imposto il pannello dell'interfaccia grafica
            this.m.paintMineField(this.sim.getMineFieldMatrix(),false);
            
            
             //visualizzazione della nuova immagine del campo minato
             m.show();
             
             //chiusura della precedente immagine del campo minato
             previus.close();
             
             this.jLabelUniminedMines.setText(""+this.sim.getTotUnminedMines());
             
             if(this.sim.isSimEnded()) this.jButtonStopActionPerformed(new java.awt.event.ActionEvent(this,0,"fine sim"));
            /*
            
            //aggiornamento del campo minato (interfaccia grafica)
            this.m.paintMineField(this.sim.getMineFieldMatrix());
            */
        }catch(Exception e){//eccezione nel caso in cui non sia pi in ascolto il demone relativo al nodo Tucson locale
            
            e.printStackTrace();
            //in questo caso si annulla la simulazione e si chiude la finestra relativa alla rappresentazione grafica del campo minato stesso
            this.showDialogError("Non  pi presente alcun nodo Tucson: impossibile continuare la simulazione corrente (verr terminata)","Simulation run-time error");
            
            this.sim=null;
            
            this.m.close();
            
            this.m=null;
           
            this.jButton1.setEnabled(false);
            this.jButtonStop.setEnabled(false);
        }//catch
    }//GEN-LAST:event_jButton1ActionPerformed

    private void jMenuItem1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem1ActionPerformed
        
        if(m!=null) m.close();
        
        //carico il campo minato iniziale sul pannello m
        this.loadMineField(0);
        
        
    }//GEN-LAST:event_jMenuItem1ActionPerformed
    
    /** Exit the Application */
    private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
        System.exit(0);
    }//GEN-LAST:event_exitForm
    
    /**
     *carica il campo minato sul pannello m
     *@param i: 0 se si tratta di un nuovo campo minato; 1 se si tratta dell'aggiornamento del campo minato causato dal
     *passaggio ad un nuovo turno della simulazione
     */
    private void loadMineField(int i){
        
        
        switch(i){
            
            //caricamento del campo minato iniziale
            case 0:{
                
                this.loadNewSim();
                
                break;
            }
            
            //update del campo minato
            case 1:{
            }
            
        }//switch
    }
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        
        SimulationGUI mfGUI=new SimulationGUI();
        
        mfGUI.setLocation(100,100);
        
        mfGUI.show();
    }
    
    /**
     *genera un nuovo campo minato e imposta i valori nel nodo Tucson
     */
    /*private void generateNewMineField(){
        
        int[][] mineField=new int[this.X_DIMENSION][this.Y_DIMENSION];
        
        
        //generazione
        for(int i=0;i<sid.gui.SimulationGUI.Y_DIMENSION;i++){
             
             //scansione delle colonne
             for(int k=0;k<sid.gui.SimulationGUI.X_DIMENSION;k++){
                 //genero una mina con distribuzione di probabilit uniforme (50% di prob. di generare una mina e 50% di prob di non generarla)
                 mineField[i][k]=( Math.random()<=0.5 ? 0 : -1);
        
                 //dopo aver generato la mina la si inserisce nel tuple center mineField
        
             }
        }
        
        this.m.paintMineField(mineField);
        //genero una mina con distribuzione di probabilit uniforme (50% di prob. di generare una mina e 50% di prob di non generarla)
        
        
        //dopo aver generato la mina la si inserisce nel tuple center mineField
        
        //return new int[this.X_DIMENSION][this.Y_DIMENSION];
    }
    */
    /**
     *imposta e lancia in esecuzione una nuova simulazione
     *in esecuzione
     */   
    private void loadNewSim(){
        try{
            
            //chiude una precedente simulazione, se presente
            this.endPreviusSim();
            
            SetNewSimDialogGUI s=new SetNewSimDialogGUI(this,true);
            
            s.setLocation(350,280);
            s.show();
           
            
            this.sim=new Simulation(this.nA,this.nB,this.x,this.y);
            this.jButton1.setEnabled(true);
            this.jButtonStop.setEnabled(true);
            
            this.jLabelTotMines.setText(""+this.sim.getTotMines());
            this.jLabelUniminedMines.setText(""+this.sim.getTotUnminedMines());
            
            
            
            //creo il nuovo campo minato (grafica)
            m=new MineFieldGUI(this,this.x,this.y);
            
            
            //recupero la nuova posizione del frame
            Point framePos=this.getLocation();
            
            //imposto la nuova posizione del campo minato
            m.setLocation((int)framePos.getX()+200,(int)framePos.getY()+58);
           
            
            //recupero la matrice da simulation creata e imposto il pannello dell'interfaccia grafica
            this.m.paintMineField(this.sim.getMineFieldMatrix(),true);
            
            
             m.show();
            /*
            //genero il TucsonContext   
            this.cn=Tucson.enterDefaultContext();
            System.out.println("creo un nuovo contesto Tucson: "+this.cn);
            
            //provo a fare una out per vedere se il nodo  attivo: altrimenti viene lanciata l'eccezione
            this.cn.out(this.tcMineField,new LogicTuple("isActive",new Value("yes")));

            //se il nodo  attivo elimino dal tc questa tupla di prova
            this.cn.in(this.tcMineField,new LogicTuple("isActive",new Value("yes")));
            
            
            //genera i dati relativi ad un nuovo campo minato: inoltre crea anche il centro di tuple mineField utilizzato per rappresentare l'ambiente simulato
            this.generateNewMineField();
            */
        }catch(Exception e){
            
            e.printStackTrace();
            //non c' alcun nodo attivo: allora mostro un messaggio di errore 
            this.showDialogError("Non c' alcun nodo Tucson attivo: attivare un nodo Tucson e riprovare","Errore inizializzazione Simulazione");
        }
    }//loadNewSim
    
    /**
     *setta la simulazione una nuova simulazione associata alla applicazione
     *@param nA numero agenti rilevatori
     *@param nB n agenti sminatori
     *@param x numero di caselle sull'asse x
     *@param y numero di caselle sull'asse y
     *inizializzata o in esecuzione
     *
     */
     public void setSimulation(int nA,int nB,int x,int y ){
         
         this.nA=nA;
         this.nB=nB;
         this.x=x;
         this.y=y;
         
     }//setSimulation
    
     
     
     /**
      *utilizzato per terminare, se presente, una simulazione in corso
      *
      */
     private void endPreviusSim()throws Exception{
         
         if(this.sim!=null){
             this.sim.endSim();
         }//if
         
     }//endPreviusSim
     
     
    /**
     *restituisce al chiamante la simulazione attualmente 
     *associata all'interfaccia grafica
     *@return la simulazione corrente
     */
     public Simulation getSimulation(){
         
         return this.sim;
     }//getSimulation
    /**
     *mostra all'utente una finestra di dialogo di errore
     *@param errore descrizione dell'errore
     *@param titolo titolo di errore della finestra di dialogo
     */
    public void showDialogError(String err,String titolo){
        javax.swing.JOptionPane.showMessageDialog(this, err,titolo,javax.swing.JOptionPane.ERROR_MESSAGE);
    }
    
    /**
     *mostra all'utente una finestra di dialogo informativo
     *@param text messaggio informativo
     *@param titolo titolo di errore della finestra di dialogo
     */
    public void showDialogInfo(String text,String titolo){
        javax.swing.JOptionPane.showMessageDialog(this, text,titolo,javax.swing.JOptionPane.INFORMATION_MESSAGE);
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel jLabelUniminedMines;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JButton jButtonStop;
    private javax.swing.JMenuItem jMenuItem2;
    private javax.swing.JButton jButton1;
    private javax.swing.JMenuItem jMenuItem1;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabelTotMines;
    private javax.swing.JMenu jMenu1;
    private javax.swing.JMenuBar jMenuBar1;
    // End of variables declaration//GEN-END:variables
    
}
