
%carico libreria tucson

%:-load_library('alice.tucson.api.Tucson2PLibrary').





  




doAction(S):-
			member(free(X,Y),S),    %ottengo una cella libera attorno all'agente
			(
				preCond(free(X,Y)),!,                   %si controlla che il movimento verso la cella libera soddisfi le precondizioni
				myPos(Xstart,Ystart),                   %recupero della posizione attuale dell'agente
				move(from(Xstart,Ystart),to(X,Y),0);
				
				%eseguo il movimento verso la cella selezionata (rispetta le precondizioni)
				
				%movimento non rispettante le precondizioni: altra parte del body
				delete(free(X,Y),S,SNew), %cancello da S la cella non consentita per il movimento
				doAction(SNew)		  %ripeto la ricerca dell'azione con il nuovo stato
			).
			

%esegue una azione consentita il base allo stato 
%lo stato  una lista con la situazione delle celle adiacenti alla posizione dell'agente detect
%S: lista che rappresenta lo stato del campo minato attorno all'agente detect

%usata nel momento in cui non ci sono pi caselle libere da controllare
doAction([H1|T1]):-
			myPos(Xstart,Ystart),
			visited(Xstart,Ystart,prev(X1,Y1),[]),!,
			
			move(from(Xstart,Ystart),to(X1,Y1),1).

doAction([H1|T1]):-
			myPos(Xstart,Ystart),
			visited(Xstart,Ystart,none,[H|T]),!,
		      
			length([H|T],Lung),
			element(Lung,[H|T],next(X2,Y2)),
			move(from(Xstart,Ystart),to(X2,Y2),2).



doAction([H1|T1]):-
			myPos(Xstart,Ystart),
			visited(Xstart,Ystart,prev(X1,Y1),[H|T]),
			( backDirection(down),!,
			  move(from(Xstart,Ystart),to(X1,Y1),1);

                    length([H|T],Lung),
			  element(Lung,[H|T],next(X2,Y2)),
			  move(from(Xstart,Ystart),to(X2,Y2),2)
			).






%verifica che vi siano le precondizioni per muovere su una cella data ( free(X,Y) )



preCond(free(X,Y)):-
		
			not visited(X,Y,PrevCell,NextCell).    %e che non si tratti di una casella gi visitata


%effettuo il movimento vero e proprio: Type:0 se movimento verso cella nuova,1 se movimento verso cella precedente
							% 2 se movimento verso cella successiva

move(from(X1,Y1),to(X2,Y2),Type):-
			assert(agentNewPos(X2,Y2,Type)).      %movimento: questo fatto verr poi preso in consegna dal codice Java.
			
			
%per Type: vedi move

update(from(Xstart,Ystart),to(X,Y),Type):-

			retract(myPos(_,_)),      %l'agente non si trova pi nella vecchia posizione
		      assert(myPos(X,Y)),       %nuova posizione dell'agente
			Type is 0,!,
                  retract(visited(Xstart,Ystart,Prev,Next)),
			append([next(X,Y)],Next,NewNext),
			assert(visited(Xstart,Ystart,Prev,NewNext)),
			assert(visited(X,Y,prev(Xstart,Ystart),[])).

update(from(Xstart,Ystart),to(X,Y),Type):-

			retract(myPos(_,_)),      %l'agente non si trova pi nella vecchia posizione
		      assert(myPos(X,Y)),
			Type is 1,!,
                  retract(backDirection(_)),
			assert(backDirection(down)).
			

update(from(Xstart,Ystart),to(X,Y),Type):-

			retract(myPos(_,_)),      %l'agente non si trova pi nella vecchia posizione
		      assert(myPos(X,Y)),
			Type is 2,!,
                  visited(Xstart,Ystart,Prev,[H|T]),!,
		      retract(backDirection(_)),
			assert(backDirection(up)),
			length([H|T],Lung),
			element(Lung,[H|T],next(X2,Y2)),
			delete(next(X2,Y2),[H|T],NextNew),
			append([next(X2,Y2)],NextNew,Target),
			retract(visited(Xstart,Ystart,Prev,[H|T])),
			assert(visited(Xstart,Ystart,Prev,Target)).


backDirection(down).


changeDirection:-
			retract(backDirection(Dir)),
			(
				Dir==down,!,
				assert(backDirection(up));
				assert(backDirection(down))
			).
				

