%pianifica, data una mina e una lista di celle dichiarate libere un possibile percorso dalla pos dell'agente alla mina (se esiste)

%tmpPos(0,5).
%myPos(0,5).
%piano([]).
%actualDist(3).
%initialState([free(1,6,d1),free(0,6,d2),free(2,4,d3)]).



plan([],mine(X,Y,none)):-!,
		retract(piano(_)),
		assert(piano([])),
		retract(tmpPos(_,_)).

plan(S,mine(X,Y,none)):-	
			actualDist(D),
			D < 2.0,!,
			piano(Plan),
			append(Plan,[mine(X,Y,none)],PlanDef),
			retract(piano(_)),
			assert(piano(PlanDef)),
			retract(tmpPos(_,_)).


plan(S,mine(X,Y,none)):-		
			copy_term(S,SCopy),
			adiacent(SCopy,ADList),
			(
				ADList==[],!,
				piano(Plan),
				length(Plan,Lung),
				(
				Lung is 0,!,
				plan([],mine(X,Y,none));



				element(Lung,Plan,free(Xd,Yd,Name)),
				initialState(Sinit),
				delete(free(Xd,Yd,Name),Sinit,SinitNew),
				retract(initialState(_)),
				assert(initialState(SinitNew)),
				retract(piano(_)),
				assert(piano([])),
				retract(tmpPos(_,_)),
			        myPos(Xs,Ys),
			        assert(tmpPos(Xs,Ys)),
				plan(SinitNew,mine(X,Y,none))
				);
				
				calculateMinDistCell(ADList,mine(X,Y,none),free(X2,Y2,Name),D),
				retract(actualDist(_)),
				assert(actualDist(D)),
				retract(tmpPos(_,_)),
				assert(tmpPos(X2,Y2)),
				retract(piano(L)),
				append(L,[free(X2,Y2,Name)],LNew),
				assert(piano(LNew)),
				delete(free(X2,Y2,Name),SCopy,SNew),
				plan(SNew,mine(X,Y,none))
			 ).


%dato il fatto tmpPos, ricava la lista delle celle adiacenti da L

adiacent(L,AdList):-
			aggiungiAdiacent(L,[],AdList).


aggiungiAdiacent([],L1,L1):-!.



aggiungiAdiacent(L,L1,Ad):-
				element(1,L,free(X,Y,Name)),
				delete(free(X,Y,Name),L,LNew),
				(
					isAdiacent(X,Y),!,
					append(L1,[free(X,Y,Name)],L1New),	
					aggiungiAdiacent(LNew,L1New,Ad);

					aggiungiAdiacent(LNew,L1,Ad)
				).





isAdiacent(X,Y):-	
				tmpPos(Xa,Ya),	
				X is Xa-1,
				Y is Ya-1,!.

isAdiacent(X,Y):-	
				tmpPos(Xa,Ya),	
				X is Xa-1,
				Y is Ya,!.

isAdiacent(X,Y):-	
				tmpPos(Xa,Ya),	
				X is Xa-1,
				Y is Ya+1,!.

isAdiacent(X,Y):-	
				tmpPos(Xa,Ya),	
				X is Xa,
				Y is Ya-1,!.

isAdiacent(X,Y):-	
				tmpPos(Xa,Ya),	
				X is Xa,
				Y is Ya+1,!.

isAdiacent(X,Y):-	
				tmpPos(Xa,Ya),	
				X is Xa+1,
				Y is Ya-1,!.

isAdiacent(X,Y):-	
				tmpPos(Xa,Ya),	
				X is Xa+1,
				Y is Ya,!.

isAdiacent(X,Y):-	
				tmpPos(Xa,Ya),	
				X is Xa+1,
				Y is Ya+1,!.



calculateMinDistCell(ADList,mine(X,Y,none),free(X2,Y2,Name),D):-
				calcolaDist(ADList,mine(X,Y,none),Res),
				minDistCell(Res,D,free(X2,Y2,Name)).
				%element(Index,ADList,free(X2,Y2,Name)).


calcolaDist([],mine(X,Y,none),Res,Res):-!.

calcolaDist(ADList,mine(X,Y,none),L,Res):-
				element(1,ADList,free(Xa,Ya,Name)),
				class("sid.util.UnMineUtility") <- getDist(X,Y,Xa,Ya) returns Dist,
				delete(free(Xa,Ya,Name),ADList,ADListNew),
				append(L,[free(Xa,Ya,Name,Dist)],LNew),
				calcolaDist(ADListNew,mine(X,Y,none),LNew,Res).

calcolaDist(ADList,mine(X,Y,none),Res):-
				calcolaDist(ADList,mine(X,Y,none),[],Res).
				

minDistCell([],First,First,NewElement,free(Xa,Ya,N1),free(Xa,Ya,N1)):-!.


minDistCell(List,First,ActualDist,NewElement,free(Xa,Ya,N1),free(X2,Y2,Name)):-
			
			element(1,List,free(Xb,Yb,N2,Actual)),
			delete(free(Xb,Yb,N2,Actual),List,NewList),
			NextElement is NewElement +1,  
			
			(
				Actual<First,!,
		
				minDistCell(NewList,Actual,ActualDist,NextElement,free(Xb,Yb,N2),free(X2,Y2,Name));
				
				minDistCell(NewList,First,ActualDist,NextElement,free(Xa,Ya,N1),free(X2,Y2,Name))
				
			 ).

				


minDistCell(List,D,free(X2,Y2,Name)):-	

			element(1,List,free(Xa,Ya,N1,ActualDist)),
			delete(free(Xa,Ya,N1,ActualDist),List,NewList),
			minDistCell(NewList,ActualDist,D,1,free(Xa,Ya,N1),free(X2,Y2,Name)).


updatePlan(L):-
			retract(piano(_)),
			assert(piano(L)).


backDirection(down).


changeDirection:-
			retract(backDirection(Dir)),
			(
				Dir==down,!,
				assert(backDirection(up));
				assert(backDirection(down))
			).



%moveToFreeCell(S,actual(Xa,Ya),res(X,Y)):-
%						adiacent(S,ADList),
%						(
%							ADList==[],!,
%							X=Xa,Y=Ya;
%							element(1,ADList,free(Xf,Yf,AgName)),
%							(
%								not visited(Xf,Yf,_),!,
%								X=Xf,Y=Xf;
%								delete(free(Xf,Yf,AgName),S,SNew),
%								moveToFreeCell(SNew,actual(Xa,Ya),res(X,Y))
%							)
%						).
